<a name="SmartclipApi"></a>

## SmartclipApi
**Kind**: global class  

* [SmartclipApi](#SmartclipApi)
    * [new SmartclipApi(playerProxy, config)](#new_SmartclipApi_new)
    * [.adInfo](#SmartclipApi+adInfo) ⇒ <code>AdInfo</code>
    * [.adInteractiveState](#SmartclipApi+adInteractiveState) ⇒ <code>Boolean</code>
    * [.adCompanions](#SmartclipApi+adCompanions) ⇒ <code>Array</code>
    * [.adExtensions](#SmartclipApi+adExtensions) ⇒ <code>Array</code>
    * [.initAdSlot(adBreak, environmentVars)](#SmartclipApi+initAdSlot) ⇒ <code>Promise</code>
    * [.startAdSlot()](#SmartclipApi+startAdSlot)
    * [.stopAdSlot()](#SmartclipApi+stopAdSlot)
    * [.skipAd()](#SmartclipApi+skipAd)
    * [.resize(boundingRectangle, viewMode)](#SmartclipApi+resize)
    * [.clickThrough()](#SmartclipApi+clickThrough)
    * [.pauseAd()](#SmartclipApi+pauseAd)
    * [.resumeAd()](#SmartclipApi+resumeAd)

<a name="new_SmartclipApi_new"></a>

### new SmartclipApi(playerProxy, config)

| Param | Type | Description |
| --- | --- | --- |
| playerProxy | <code>Object</code> | extended from [FacadeBase](FacadeBase) |
| config | <code>Object</code> | Global configuration |

<a name="SmartclipApi+adInfo"></a>

### smartclipApi.adInfo ⇒ <code>AdInfo</code>
Combination of generic properties of all types of ads and custom properties that depend on VAST Extensions.

**Kind**: instance property of <code>[SmartclipApi](#SmartclipApi)</code>  
**Returns**: <code>AdInfo</code> - Represents static information about the current ad  
<a name="SmartclipApi+adInteractiveState"></a>

### smartclipApi.adInteractiveState ⇒ <code>Boolean</code>
Returns whether the current ad is interactive (most likely by using __VPAID__) or not.

**Kind**: instance property of <code>[SmartclipApi](#SmartclipApi)</code>  
**Returns**: <code>Boolean</code> - True if the current ad has been specified as interactive  
<a name="SmartclipApi+adCompanions"></a>

### smartclipApi.adCompanions ⇒ <code>Array</code>
The value of this property is an Array that provides ad companion details in VAST 3.0 format for the `<CompanionAds>` element.
The video player should request this value whenever it receives the `ON_COMPANIONS_DETECTED` add-on event.

**Kind**: instance property of <code>[SmartclipApi](#SmartclipApi)</code>  
**Returns**: <code>Array</code> - List of all companion ads  
<a name="SmartclipApi+adExtensions"></a>

### smartclipApi.adExtensions ⇒ <code>Array</code>
The value of this property is an Array that provides ad extension details for the `<Extensions>` element.
The video player should request this value whenever it receives the **ON_EXTENSIONS_DETECTED** add-on event.

**Kind**: instance property of <code>[SmartclipApi](#SmartclipApi)</code>  
**Returns**: <code>Array</code> - List of all extensions  
<a name="SmartclipApi+initAdSlot"></a>

### smartclipApi.initAdSlot(adBreak, environmentVars) ⇒ <code>Promise</code>
Invokes a commercial break by requesting the specified ad setup from the ad server.

**Kind**: instance method of <code>[SmartclipApi](#SmartclipApi)</code>  
**Returns**: <code>Promise</code> - Resolves if loading the ad manifests has been completed  

| Param | Type | Description |
| --- | --- | --- |
| adBreak | <code>AdBreak</code> | Configuration for the upcoming ad break. |
| environmentVars | <code>EnvironmentVars</code> | Defines environment conditions for the upcoming ad break |

<a name="SmartclipApi+startAdSlot"></a>

### smartclipApi.startAdSlot()
Starts the ad break.
The add-on responds by sending an `ON_AD_SLOT_START` event notifying the video player the ad break is going to start.

**Kind**: instance method of <code>[SmartclipApi](#SmartclipApi)</code>  
<a name="SmartclipApi+stopAdSlot"></a>

### smartclipApi.stopAdSlot()
Stops a running ad break.
The add-on responds by sending an `ON_AD_SLOT_COMPLETE` event notifying the video player it has closed and cleaned up
ad resources. Also the content of the video player has been reseted.

**Kind**: instance method of <code>[SmartclipApi](#SmartclipApi)</code>  
<a name="SmartclipApi+skipAd"></a>

### smartclipApi.skipAd()
Skips (stops) a running single ad
The add-on respondes by sending the `ON_AD_SKIPPED` event notifying the video player it has closed and cleaned up
a single ad.

_Note: The add-on does proceed with the next ad. Canceling the whole ad break requires calling `stopAdSlot()` instead.

**Kind**: instance method of <code>[SmartclipApi](#SmartclipApi)</code>  
<a name="SmartclipApi+resize"></a>

### smartclipApi.resize(boundingRectangle, viewMode)
Following a resize of the video player, the video player calls `resize()` to allow the add-on
to scale and reposition itself within the display area. The add-on responds by sending an 'ON_AD_SIZE_CHANGED` event.

**Kind**: instance method of <code>[SmartclipApi](#SmartclipApi)</code>  

| Param | Type | Description |
| --- | --- | --- |
| boundingRectangle | <code>Rectangle</code> | The video content display as a Rectangle {width, height, top, left} |
| viewMode | <code>string</code> | Current viewing mode (normal, fullscreen, thumbnail, dynamic) |

<a name="SmartclipApi+clickThrough"></a>

### smartclipApi.clickThrough()
Following a click on the ad, the video player calls `clickThrough()` to allow the add-on
to request the advertisers landing page and call the ClickThru tracking requests.

**Kind**: instance method of <code>[SmartclipApi](#SmartclipApi)</code>  
<a name="SmartclipApi+pauseAd"></a>

### smartclipApi.pauseAd()
Pauses the current ad break. The add-on responds by sending the `ON_AD_PAUSED` event.

**Kind**: instance method of <code>[SmartclipApi](#SmartclipApi)</code>  
<a name="SmartclipApi+resumeAd"></a>

### smartclipApi.resumeAd()
Resumes the current ad break. The add-on responds by sending the `ON_AD_PLAYING` event.

**Kind**: instance method of <code>[SmartclipApi](#SmartclipApi)</code>  
